com.fasterxml.jackson.databind.deser.impl

## Class FieldProperty

- java.lang.Object
- - com.fasterxml.jackson.databind.introspect.ConcreteBeanPropertyBase
  - - com.fasterxml.jackson.databind.deser.SettableBeanProperty
    - - com.fasterxml.jackson.databind.deser.impl.FieldProperty

All Implemented Interfaces:
  BeanProperty, Named, Serializable

    public final class FieldProperty
    extends SettableBeanProperty

This concrete sub-class implements property that is set directly assigning to a Field.

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.deser.SettableBeanProperty

`SettableBeanProperty.Delegating`

### Nested classes/interfaces inherited from interface com.fasterxml.jackson.databind.BeanProperty

`BeanProperty.Bogus, BeanProperty.Std`

### Field Summary

Fields
`protected AnnotatedField` `_annotated`
`protected Field` `_field` Actual field to set when deserializing this property.
`protected boolean` `_skipNulls`

### Fields inherited from class com.fasterxml.jackson.databind.deser.SettableBeanProperty

`_contextAnnotations, _managedReferenceName, _nullProvider, _objectIdInfo, _propertyIndex, _propName, _type, _valueDeserializer, _valueTypeDeserializer, _viewMatcher, _wrapperName, MISSING_VALUE_DESERIALIZER`

### Fields inherited from class com.fasterxml.jackson.databind.introspect.ConcreteBeanPropertyBase

`_aliases, _metadata`

### Fields inherited from interface com.fasterxml.jackson.databind.BeanProperty

`EMPTY_FORMAT, EMPTY_INCLUDE`

### Constructor Summary

Constructors
`` `FieldProperty(BeanPropertyDefinition propDef, JavaType type, TypeDeserializer typeDeser, Annotations contextAnnotations, AnnotatedField field)`
`protected` `FieldProperty(FieldProperty src)` Constructor used for JDK Serialization when reading persisted object
`protected` `FieldProperty(FieldProperty src, JsonDeserializer<?> deser, NullValueProvider nva)`
`protected` `FieldProperty(FieldProperty src, PropertyName newName)`

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `deserializeAndSet(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt, Object instance)` Method called to deserialize appropriate value, given parser (and context), and set it using appropriate mechanism.

`Object`

`deserializeSetAndReturn(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt, Object instance)`
Alternative to `SettableBeanProperty.deserializeAndSet(com.fasterxml.jackson.core.JsonParser, com.fasterxml.jackson.databind.DeserializationContext, java.lang.Object)` that returns either return value of setter method called (if one is), or null to indicate that no return value is available.

`void` `fixAccess(DeserializationConfig config)` Method called to ensure that the mutator has proper access rights to be called, as per configuration.
`<A extends Annotation> A` `getAnnotation(Class<A> acls)` Method for finding annotation associated with this property; meaning annotation associated with one of entities used to access property.
`AnnotatedMember` `getMember()` Method for accessing primary physical entity that represents the property; annotated field, method or constructor property.
`void` `set(Object instance, Object value)` Method called to assign given value to this property, on specified Object.
`Object` `setAndReturn(Object instance, Object value)` Method called to assign given value to this property, on specified Object, and return whatever delegating accessor returned (if anything) Note: this is an optional operation, not supported by all implementations, creator-backed properties for example do not support this method.
`SettableBeanProperty` `withName(PropertyName newName)` Fluent factory method for constructing and returning a new instance with specified property name.
`SettableBeanProperty` `withNullProvider(NullValueProvider nva)`
`SettableBeanProperty` `withValueDeserializer(JsonDeserializer<?> deser)` Fluent factory method for constructing and returning a new instance with specified value deserializer.

### Methods inherited from class com.fasterxml.jackson.databind.deser.SettableBeanProperty

`_throwAsIOE, _throwAsIOE, _throwAsIOE, _throwAsIOE, assignIndex, depositSchemaProperty, deserialize, deserializeWith, getContextAnnotation, getCreatorIndex, getDeclaringClass, getFullName, getInjectableValueId, getManagedReferenceName, getName, getNullValueProvider, getObjectIdInfo, getPropertyIndex, getType, getValueDeserializer, getValueTypeDeserializer, getWrapperName, hasValueDeserializer, hasValueTypeDeserializer, hasViews, isIgnorable, isInjectionOnly, markAsIgnorable, setManagedReferenceName, setObjectIdInfo, setViews, toString, visibleInView, withSimpleName`

### Methods inherited from class com.fasterxml.jackson.databind.introspect.ConcreteBeanPropertyBase

`findAliases, findFormatOverrides, findPropertyFormat, findPropertyInclusion, getMetadata, isRequired, isVirtual`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Field Detail

#### _annotated

    protected final AnnotatedField _annotated

#### _field

    protected final transient Field _field

Actual field to set when deserializing this property. Transient since there is no need to persist; only needed during construction of objects.

#### _skipNulls

    protected final boolean _skipNulls

Since:
  2.9

### Constructor Detail

#### FieldProperty

    public FieldProperty(BeanPropertyDefinition propDef,
                         JavaType type,
                         TypeDeserializer typeDeser,
                         Annotations contextAnnotations,
                         AnnotatedField field)

#### FieldProperty

    protected FieldProperty(FieldProperty src,
                            JsonDeserializer<?> deser,
                            NullValueProvider nva)

#### FieldProperty

    protected FieldProperty(FieldProperty src,
                            PropertyName newName)

#### FieldProperty

    protected FieldProperty(FieldProperty src)

Constructor used for JDK Serialization when reading persisted object

### Method Detail

#### withName

    public SettableBeanProperty withName(PropertyName newName)

Description copied from class: `SettableBeanProperty`
Fluent factory method for constructing and returning a new instance with specified property name. Note that this method should NOT change configuration of this instance.

Specified by:
  `withName` in class `SettableBeanProperty`
Parameters:
  `newName` - Name to use for the new instance.
Returns:
  Newly constructed instance, if property name differs from the one used for this instance; or 'this' if not.

#### withValueDeserializer

    public SettableBeanProperty withValueDeserializer(JsonDeserializer<?> deser)

Description copied from class: `SettableBeanProperty`
Fluent factory method for constructing and returning a new instance with specified value deserializer. Note that this method should NOT change configuration of this instance.

Specified by:
  `withValueDeserializer` in class `SettableBeanProperty`
Parameters:
  `deser` - Deserializer to assign to the new property instance
Returns:
  Newly constructed instance, if value deserializer differs from the one used for this instance; or 'this' if not.

#### withNullProvider

    public SettableBeanProperty withNullProvider(NullValueProvider nva)

Specified by:
  `withNullProvider` in class `SettableBeanProperty`

#### fixAccess

    public void fixAccess(DeserializationConfig config)

Description copied from class: `SettableBeanProperty`
Method called to ensure that the mutator has proper access rights to be called, as per configuration. Overridden by implementations that have mutators that require access, fields and setters.

Overrides:
  `fixAccess` in class `SettableBeanProperty`

#### getAnnotation

    public <A extends Annotation> A getAnnotation(Class<A> acls)

Description copied from interface: `BeanProperty`
Method for finding annotation associated with this property; meaning annotation associated with one of entities used to access property.

Note that this method should only be called for custom annotations; access to standard Jackson annotations (or ones supported by alternate `AnnotationIntrospector`s) should be accessed through `AnnotationIntrospector`.

Specified by:
  `getAnnotation` in interface `BeanProperty`
Specified by:
  `getAnnotation` in class `SettableBeanProperty`

#### getMember

    public AnnotatedMember getMember()

Description copied from interface: `BeanProperty`
Method for accessing primary physical entity that represents the property; annotated field, method or constructor property.

Specified by:
  `getMember` in interface `BeanProperty`
Specified by:
  `getMember` in class `SettableBeanProperty`

#### deserializeAndSet

    public void deserializeAndSet(com.fasterxml.jackson.core.JsonParser p,
                                  DeserializationContext ctxt,
                                  Object instance)
                           throws IOException

Description copied from class: `SettableBeanProperty`
Method called to deserialize appropriate value, given parser (and context), and set it using appropriate mechanism. Pre-condition is that passed parser must point to the first token that should be consumed to produce the value (the only value for scalars, multiple for Objects and Arrays).

Specified by:
  `deserializeAndSet` in class `SettableBeanProperty`
Throws:
  `IOException`

#### deserializeSetAndReturn

    public Object deserializeSetAndReturn(com.fasterxml.jackson.core.JsonParser p,
                                          DeserializationContext ctxt,
                                          Object instance)
                                   throws IOException

Description copied from class: `SettableBeanProperty`
Alternative to `SettableBeanProperty.deserializeAndSet(com.fasterxml.jackson.core.JsonParser, com.fasterxml.jackson.databind.DeserializationContext, java.lang.Object)` that returns either return value of setter method called (if one is), or null to indicate that no return value is available. Mostly used to support Builder style deserialization.

Specified by:
  `deserializeSetAndReturn` in class `SettableBeanProperty`
Throws:
  `IOException`

#### set

    public void set(Object instance,
                    Object value)
             throws IOException

Description copied from class: `SettableBeanProperty`
Method called to assign given value to this property, on specified Object.

Note: this is an optional operation, not supported by all implementations, creator-backed properties for example do not support this method.

Specified by:
  `set` in class `SettableBeanProperty`
Throws:
  `IOException`

#### setAndReturn

    public Object setAndReturn(Object instance,
                               Object value)
                        throws IOException

Description copied from class: `SettableBeanProperty`
Method called to assign given value to this property, on specified Object, and return whatever delegating accessor returned (if anything)

Note: this is an optional operation, not supported by all implementations, creator-backed properties for example do not support this method.

Specified by:
  `setAndReturn` in class `SettableBeanProperty`
Throws:
  `IOException`